/* structs.h for fitsjd   */
/* Data structures  */
#ifndef _jd_structs
#define _jd_structs
#include <fitsio.h>
#include "consts.h"

typedef unsigned short int PIXEL;
typedef unsigned char BYTE;

typedef
struct {
  int simple;
  long bitpix;
  long naxis, nax[2];
  fitsfile *fptr;
  char ctype1[9], ctype2[9];
  double crval1, crval2;  /* Celestial coordinates of the reference pixel (in decimal degrees) */
  double crpix1, crpix2;  /* Image coordinates of the reference pixel  */
  double cdelt1, cdelt2;  /* Coordinate incremement at reference pixel  */
  double crot;            /* Rotation angle (should be the same for both axis */
  char ctype[5];          /* Projection type (like -TAN)  */
  short wcs;              /* Flag which is set if wcs coordinates are present  */
  int matched;          /* This is set if WCS coordinates were matched to catalog */
  float sizex, sizey;
  char telescope[FLEN_VALUE];
  char instrument[FLEN_VALUE];
  char observer[FLEN_VALUE];
  char date_obs[FLEN_VALUE];
  char ut_start[20];
  char ut_cent[20];
  char ut_end[20];
  char time_beg[20];
  char time_end[20];
  char object[FLEN_VALUE];     /*  Name of the object  */
  /*  Flags which tell whether specific keyword was read  */
  short is_date_obs;
  short is_exposure;
  short is_ut_start;
  short is_ut_cent;
  short is_ut_end;
  short is_time_beg;
  short is_time_end;
  char time[9];
  float exposure;
  float ccd_temp;
  float temperat, pressure, humidity;
  float equinox;
  char *name;
  double jd;
} FITSFILE;


#endif



